import "reflect-metadata";
import { API } from "lambda-api";
import { Server } from "./api/Server";
import { Container } from "inversify";
import { AppConfig } from "./model/AppConfig";
import { ApiRequest } from "./model/ApiRequest";
import { ApiResponse } from "./model/ApiResponse";
export declare abstract class ApiApp {
    protected readonly apiServer: Server;
    protected readonly appContainer: Container;
    constructor(appConfig?: AppConfig, appContainer?: Container);
    /**
     * Configure the IOC container instance.
     */
    configureApp(configureBlock: (this: void, container: Container) => void): void;
    /**
     * Configure the lambda-api API instance.
     */
    configureApi(configureBlock: (this: void, api: API) => void): void;
    abstract run(event: ApiRequest, context: any): Promise<ApiResponse>;
    protected initialiseControllers(controllersPath: string): Promise<void>;
}
