"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
require("reflect-metadata");
const Server_1 = require("./api/Server");
const inversify_1 = require("inversify");
const AppConfig_1 = require("./model/AppConfig");
class ApiApp {
    constructor(appConfig, appContainer) {
        this.appContainer = appContainer || new inversify_1.Container({ autoBindInjectable: true });
        this.apiServer = new Server_1.Server(appConfig || new AppConfig_1.AppConfig());
    }
    /**
     * Configure the IOC container instance.
     */
    configureApp(configureBlock) {
        configureBlock(this.appContainer);
    }
    /**
     * Configure the lambda-api API instance.
     */
    configureApi(configureBlock) {
        this.apiServer.configure(configureBlock);
    }
    async initialiseControllers(controllersPath) {
        await this.apiServer.discoverAndBuildRoutes(controllersPath, this.appContainer);
    }
}
exports.ApiApp = ApiApp;
//# sourceMappingURL=ApiApp.js.map