"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const DecoratorRegistry_1 = require("../DecoratorRegistry");
/**
 * decorators for controller endpoint methods, a path
 * for the endpoint can be specified
 */
function GET(path = "") {
    return (classDefinition, methodName) => registerApiEndpoint(classDefinition, methodName, path, "GET");
}
exports.GET = GET;
function POST(path = "") {
    return (classDefinition, methodName) => registerApiEndpoint(classDefinition, methodName, path, "POST");
}
exports.POST = POST;
function PUT(path = "") {
    return (classDefinition, methodName) => registerApiEndpoint(classDefinition, methodName, path, "PUT");
}
exports.PUT = PUT;
function DELETE(path = "") {
    return (classDefinition, methodName) => registerApiEndpoint(classDefinition, methodName, path, "DELETE");
}
exports.DELETE = DELETE;
function PATCH(path = "") {
    return (classDefinition, methodName) => registerApiEndpoint(classDefinition, methodName, path, "PATCH");
}
exports.PATCH = PATCH;
function registerApiEndpoint(classDefinition, methodName, path, httpMethod) {
    let controller = DecoratorRegistry_1.DecoratorRegistry.getOrCreateController(classDefinition.constructor);
    let endpoint = DecoratorRegistry_1.DecoratorRegistry.getOrCreateEndpoint(controller, methodName);
    endpoint.httpMethod = httpMethod;
    endpoint.path = path;
}
//# sourceMappingURL=endpoints.js.map