"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const DecoratorRegistry_1 = require("../DecoratorRegistry");
const PathParameterExtractor_1 = require("../parameters/PathParameterExtractor");
function pathParam(paramName) {
    return (classDefinition, methodName, paramIndex) => {
        let controller = DecoratorRegistry_1.DecoratorRegistry.getOrCreateController(classDefinition.constructor);
        let endpoint = DecoratorRegistry_1.DecoratorRegistry.getOrCreateEndpoint(controller, methodName);
        endpoint.parameterExtractors[paramIndex] = new PathParameterExtractor_1.PathParameterExtractor(paramName);
    };
}
exports.pathParam = pathParam;
//# sourceMappingURL=pathParam.js.map