"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const DecoratorRegistry_1 = require("../DecoratorRegistry");
const QueryParameterExtractor_1 = require("../parameters/QueryParameterExtractor");
function queryParam(paramName) {
    return (classDefinition, methodName, paramIndex) => {
        let controller = DecoratorRegistry_1.DecoratorRegistry.getOrCreateController(classDefinition.constructor);
        let endpoint = DecoratorRegistry_1.DecoratorRegistry.getOrCreateEndpoint(controller, methodName);
        endpoint.parameterExtractors[paramIndex] = new QueryParameterExtractor_1.QueryParameterExtractor(paramName);
    };
}
exports.queryParam = queryParam;
//# sourceMappingURL=queryParam.js.map