"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class EndpointInfo {
    constructor(name, controller, methodName) {
        this.name = name;
        this.controller = controller;
        this.methodName = methodName;
        this.method = this.controller.classConstructor.prototype[methodName];
        if (this.method === undefined) {
            throw new Error(`Unable to read method parameters for endpoint '${this.methodName}' in controller '${controller.name}', ` +
                "this normally happens when you have two controllers with the same class name");
        }
        this.parameterExtractors = Array(this.method.length);
    }
}
exports.EndpointInfo = EndpointInfo;
//# sourceMappingURL=EndpointInfo.js.map