import { METHODS } from "lambda-api";
import { ApiRequest } from "../model/ApiRequest";
export declare class RequestBuilder {
    private readonly method;
    private readonly path;
    private readonly httpHeaders;
    private readonly httpQueryParams;
    private httpBody;
    private constructor();
    static get(path: string): RequestBuilder;
    static post(path: string): RequestBuilder;
    static put(path: string): RequestBuilder;
    static patch(path: string): RequestBuilder;
    static delete(path: string): RequestBuilder;
    static do(method: METHODS, path: string): RequestBuilder;
    header(key: string, value: string): this;
    headers(httpHeaders: {
        [key: string]: string;
    }): this;
    query(key: string, value: string): this;
    queryParams(params: {
        [key: string]: string;
    }): this;
    body(value: string): this;
    private mapToObject;
    build(): ApiRequest;
}
